from monosodium_glutamate import utils
import requests
from monosodium_glutamate import api_types


def get_user_from_id(user_id: int, api=api_types.e621):
    user = f"{api}/users/{user_id}.json"
    data = requests.get(user, headers=utils.user_agent).json()
    return User(data)


class User:
    def __init__(self, user: dict):
        # Lots of variables to provide the end user with an easier experience
        self.creation_time = utils.readable_date(user["created_at"])
        self.comment_count = user["comment_count"]
        self.flag_count = user["flag_count"]
        self.level = user["level"]
        self.name = user["name"]
        self.level_name = user["level_string"]
        self.post_count = user["post_upload_count"]
        self.base_upload_limit = user["base_upload_limit"]
        self.post_update_count = user["post_update_count"]
        self.upload_limit = user["upload_limit"]
        self.is_banned = user["is_banned"]
        self.can_approve_posts = user["can_approve_posts"]
        self.positive_feedback_count = user["positive_feedback_count"]
        self.neutral_feedback_count = user["neutral_feedback_count"]
        self.negative_feedback_count = user["negative_feedback_count"]
        self.id = user["id"]
        self.wiki_page_version_count = user["wiki_page_version_count"]
        self.artist_version_count = user["artist_version_count"]
        self.pool_version_count = user["pool_version_count"]
        self.forum_post_count = user["forum_post_count"]
        self.note_update_count = user["note_update_count"]
        self.can_upload_free = user["can_upload_free"]
        self.appeal_count = user["appeal_count"]
